/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package v1alpha1

import (
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

// EDIT THIS FILE!  THIS IS SCAFFOLDING FOR YOU TO OWN!
// NOTE: json tags are required.  Any new fields you add must have json tags for the fields to be serialized.

// GitlabPagesSiteSpec defines the desired state of GitlabPagesSite
type GitlabPagesSiteSpec struct {
	// Anonymous defines if the site needs authentication or not
	// +kubebuilder:validation:Optional
	// +kubebuilder:validation:Enum=true;false
	// +kubebuilder:default:=false
	Anonymous bool `json:"anonymous,omitempty"`
	// Host defines the URL
	// +kubebuilder:validation:Required
	Host string `json:"host"`
}

// GitlabPagesSiteStatus defines the observed state of GitlabPagesSite
type GitlabPagesSiteStatus struct {
	// INSERT ADDITIONAL STATUS FIELD - define observed state of cluster
	// Important: Run "make" to regenerate code after modifying this file
}

//+kubebuilder:object:root=true
//+kubebuilder:subresource:status

// GitlabPagesSite is the Schema for the gitlabpagessites API.
// The goal of the operator is to mantain sync the Route and the configuration of a Gitlab Pages Site.
// The configuration is located on the ConfigMap
type GitlabPagesSite struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   GitlabPagesSiteSpec   `json:"spec,omitempty"`
	Status GitlabPagesSiteStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// GitlabPagesSiteList contains a list of GitlabPagesSite
type GitlabPagesSiteList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []GitlabPagesSite `json:"items"`
}

func init() {
	SchemeBuilder.Register(&GitlabPagesSite{}, &GitlabPagesSiteList{})
}
